package com.casic.dcms.mvp.model.impl;

import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.listener.OnActionResultListener;
import com.casic.dcms.mvp.model.ICleanToiletModel;
import com.casic.dcms.utils.retrofit.RetrofitServiceManager;

import rx.Observable;
import rx.Observer;
import rx.Subscription;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class CleanToiletModelImpl implements ICleanToiletModel {

    private final OnActionResultListener actionResultListener;

    public CleanToiletModelImpl(OnActionResultListener listener) {
        this.actionResultListener = listener;
    }

    /**
     * {@link ICleanToiletModel}
     */
    @Override
    public Subscription sendCleanToiletRequest(String toiletId, String userId, String lng, String lat,
                                               String startTime, String endTime, String photo, String workContent) {
        Observable<ActionResultBean> observable = RetrofitServiceManager.getCleanToiletResult(toiletId,
                userId, lng, lat, startTime, endTime, photo, workContent);
        return observable.subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(new Observer<ActionResultBean>() {
            @Override
            public void onCompleted() {

            }

            @Override
            public void onError(Throwable e) {
                if (e.getCause() != null) {
                    actionResultListener.onFailure(e);
                }
            }

            @Override
            public void onNext(ActionResultBean resultBean) {
                if (resultBean != null) {
                    actionResultListener.onSuccess(resultBean);
                }
            }
        });
    }
}
